/*
 * Copyright (c) 2015, Oracle and/or its affiliates. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2.0,
 * as published by the Free Software Foundation.
 *
 * This program is also distributed with certain software (including
 * but not limited to OpenSSL) that is licensed under separate terms, as
 * designated in a particular file or component or in included license
 * documentation.  The authors of MySQL hereby grant you an additional
 * permission to link the program and your derivative works with the
 * separately licensed software that they have included with MySQL.
 * This program is distributed in the hope that it will be useful,  but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License, version 2.0, for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */
 
#include <string>

/*
 * IMPORTANT: This file is autogenerated, do not change the code on this
 * file to properly do updates on this file please change the code at
 * <branch_root>/scripting_modules/core.js
*/

namespace shcore 
{
  std::string js_core_module="function ModuleHandler()\n"
"{\n"
"  this._module_cache = {}\n"
"\n"
"  this._find_module = function(name)\n"
"  {\n"
"    var index = 0;\n"
"    var module_path = '';\n"
"    while(index < sys.path.length && module_path == '')\n"
"    {\n"
"      var tmp_path = sys.path[index];\n"
"      var last_char = tmp_path.slice(-1);\n"
"      if (last_char != '/' && last_char != '\\\\')\n"
"        tmp_path += '/';\n"
"\n"
"      tmp_path += name + '.js';\n"
"\n"
"      if (os.file_exists(tmp_path))\n"
"        module_path = tmp_path;\n"
"      else\n"
"        index++;\n"
"    }\n"
"\n"
"    return module_path;\n"
"  }\n"
"\n"
"  this._load_module = function(name)\n"
"  {\n"
"    var module = __require(name);\n"
"    if (module)\n"
"      this._module_cache[name] = module;\n"
"    else\n"
"    {\n"
"      var path = this._find_module(name);\n"
"\n"
"      if (path)\n"
"      {\n"
"        var source = os.load_text_file(path);\n"
"        if (source)\n"
"        {\n"
"          var wrapped_source = '(function (exports){' + source + '});';\n"
"          var module_definition = __build_module(path, wrapped_source);\n"
"\n"
"          var module = {}\n"
"          module_definition(module)\n"
"\n"
"          this._module_cache[name] = module;\n"
"        }\n"
"        else\n"
"          throw ('Module ' + name + ' is empty.');\n"
"      }\n"
"    }\n"
"  }\n"
"\n"
"  this.get_module = function(name, reload)\n"
"  {\n"
"    if (typeof reload !== 'undefined' && reload)\n"
"      delete this._module_cache[name];\n"
"\n"
"    // Loads the module if not done already.\n"
"    if (typeof this._module_cache[name] === 'undefined')\n"
"    {\n"
"      // Retrieves the module path and content\n"
"      this._load_module(name);\n"
"    }\n"
"\n"
"    // If the module is on the cache then returns it\n"
"    if (typeof this._module_cache[name] !== 'undefined')\n"
"      return this._module_cache[name]\n"
"    else\n"
"      throw ('Module ' + name + ' was not found.');\n"
"  }\n"
"}\n"
"\n"
"this._module_handler = new ModuleHandler();\n"
"\n"
"\n"
"this.require = function(module_name, reload)\n"
"{\n"
"  return this._module_handler.get_module(module_name, reload);\n"
"}\n"
"\n"
"// Object.keys(object) returns the enumerable properties found directly\n"
"// on the object while iterating them also includes the ones defined on\n"
"// the prototype chain.\n"
"this.dir = function(object)\n"
"{\n"
"  var keys = []\n"
"  for(k in object)\n"
"    keys[keys.length] = k;\n"
"\n"
"  return keys;\n"
"}\n"
"\n"
"";
}
